diff mbox

[pm-qa,06/10] check the task is migrated when offlining a cpu

Message ID 1317629915-31767-6-git-send-email-daniel.lezcano@linaro.org
State Accepted
Headers show

Commit Message

Daniel Lezcano Oct. 3, 2011, 8:18 a.m. UTC
Signed-off-by: Daniel Lezcano <daniel.lezcano@linaro.org
---
 cpuhotplug/cpuhotplug_04.sh  |   71 ++++++++++++++++++++++++++++++++++++++++++
 cpuhotplug/cpuhotplug_04.txt |    1 +
 2 files changed, 72 insertions(+), 0 deletions(-)
 create mode 100644 cpuhotplug/cpuhotplug_04.sh
 create mode 100644 cpuhotplug/cpuhotplug_04.txt
diff mbox

Patch

diff --git a/cpuhotplug/cpuhotplug_04.sh b/cpuhotplug/cpuhotplug_04.sh
new file mode 100644
index 0000000..6cf944f
--- /dev/null
+++ b/cpuhotplug/cpuhotplug_04.sh
@@ -0,0 +1,71 @@ 
+#!/bin/bash
+#
+# PM-QA validation test suite for the power management on ARM
+#
+# Copyright (C) 2011, Linaro Limited.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+#
+# Contributors:
+#     Daniel Lezcano <daniel.lezcano@linaro.org> (IBM Corporation)
+#       - initial API and implementation
+#
+
+# URL : https://wiki.linaro.org/WorkingGroups/PowerManagement/Doc/QA/Scripts#cpuhotplug_04
+
+CPUBURN=../utils/cpuburn
+source ../include/functions.sh
+
+check_task_migrate() {
+    local cpu=$1
+    local cpuid=${cpu:3}
+    local cpumask=$((1 << cpuid))
+    local dirpath=$CPU_PATH/$1
+    local pid=
+    local ret=
+
+    if [ "$cpu" == "cpu0" ]; then
+	return 0
+    fi
+
+    taskset -c 0x$cpumask $CPUBURN $cpu &
+    pid=$!
+    sleep 1 # let taskset to do setaffinity before checking
+
+    ret=$(taskset -p $pid | cut -d ':' -f 2)
+    ret=$(echo $ret) # remove trailing whitespace
+    ret=$(printf "%d" 0x$ret)
+    check "affinity is set" "test $cpumask -eq $ret"
+
+    sleep 1
+    set_offline $cpu
+    ret=$?
+
+    check "offlining a cpu with affinity succeed" "test $ret -eq 0"
+
+    ret=$(taskset -p $pid | cut -d ':' -f 2)
+    ret=$(echo $ret)
+    ret=$(printf "%d" 0x$ret)
+    check "affinity changed" "test $cpumask -ne $ret"
+
+    kill $pid
+
+    # in any case we set the cpu online in case of the test fails
+    set_online $cpu
+
+    return 0
+}
+
+for_each_cpu check_task_migrate
diff --git a/cpuhotplug/cpuhotplug_04.txt b/cpuhotplug/cpuhotplug_04.txt
new file mode 100644
index 0000000..c0689a3
--- /dev/null
+++ b/cpuhotplug/cpuhotplug_04.txt
@@ -0,0 +1 @@ 
+test task is migrated with task affinity